; tento podprogram zjistuje, zda je PROMENNA v intervalu MINP az MAXP
; pokud ne, tak opravi hodnotu PROMENA tak, aby v intervalu byla

V_MEZI	MACRO	PROMENNA, MINP, MAXP
	
	LOCAL	TO_MIN, KONEC
	
	MOVLW	MINP
	SUBWF	PROMENNA,W	; >= MINP ?
	BTFSS	STATUS,C
	GOTO	TO_MIN
	MOVLW	MAXP
	SUBWF	PROMENNA,W	; <= MAXP ?
	BTFSS	STATUS,C
	GOTO	KONEC
	MOVLW	MAXP
	MOVWF	PROMENNA
	GOTO	KONEC
TO_MIN	MOVLW	MINP
	MOVWF	PROMENNA
KONEC
	ENDM

; tento podprogram zprostredkuje nabidku
;  M_UKAZATEL - pomocna promenna, ktera obsahuje index polozky
;  (K0,P0),(K1,P1),... - dvojice typu (registr, bit), ktere definuji 
;                        jednotlive klavesy
;  PRVNI - index zobrazovaciho skriptu prvni polozky nabidky
;  POSLEDNI - index zobrazovaciho skriptu posledni polozky nabidky
;  NAVRAT - navratove navesti
MENUX	MACRO	M_UKAZATEL,K0,P0,K1,P1,K2,P2,K3,P3,PRVNI, POSLEDNI, NAVRAT
	LOCAL	START, LOOP, KONEC
START	CLRF	M_UKAZATEL
	MOVLW	PRVNI - 1	; zobraz nadpis (pod)menu (musi mit index skriptu o jednicku nizsi nez prvni polozka)
	CALL	SKRIPT
LOOP	V_MEZI	M_UKAZATEL, PRVNI, POSLEDNI	; over mez promenne M_UKAZATEL
	MOVF	M_UKAZATEL,W	; ...na zaklade jeji hodnoty vyber skript
	CALL	SKRIPT	; ...a zobraz jej
	CALL	READKEY	; cekej na stisk klavesy
	BTFSC	K3,P3	; podle klavesy vyber cinost
	GOTO	NAVRAT	; odchod zpet do materske nabidky
	BTFSC	K2,P2
	GOTO	KONEC	; byla vybrana polozka
	BTFSC	K0,P0
	INCF	M_UKAZATEL,F	; zvyseni indexu
	BTFSC	K1,P1
	DECF	M_UKAZATEL,F	; snizeni indexu
	GOTO	LOOP
KONEC	MOVLW	PRVNI	; budeme provadet posun spodni hranice hodnoty...
	SUBWF	M_UKAZATEL,F	; ...a nyni zacina M_UKAZATEL od nuly
	ENDM
